"""
Creates and configures the Rookeries Flask app

:copyright: Copyright 2013-2016, Dorian Pula <dorian.pula@amber-penguin-software.ca>
:license: AGPL v3+
"""

import flask

from rookeries import database, errors, security


def make_api_app(import_name, **kwargs):
    api_app = flask.Flask(import_name, **kwargs)
    errors.attach_error_handlers_to_api_app(api_app)
    database.db.init_app(api_app)
    security.jwt.init_app(api_app)
    return api_app
