"""
Models for pages.

:copyright: Copyright 2013-2016, Dorian Pula <dorian.pula@amber-penguin-software.ca>
:license: AGPL v3+
"""

from rookeries.database import db


class Page(db.Model):
    __tablename__ = 'page'

    id = db.Column(db.Integer, primary_key=True)
    # TODO: Move out into the definition of app / container blocks.
    slug = db.Column(db.String(64), unique=True)
    title = db.Column(db.String(256))
    # TODO: Break out into content blocks.
    content = db.Column(db.String)

    # TODO: Add in content type, created, updated dates and author (based on a user).

    def __init__(self, slug, title, content):
        self.slug = slug
        self.title = title
        self.content = content

    def __repr__(self) -> str:
        return f'<JournalEntry {self.slug}>'

    def to_json(self) -> dict:
        return {
            'slug': self.slug,
            'title': self.title,
            'content': self.content,
        }
