/*
Site header

@copyright (c) Copyright 2013-2016 Dorian Pula
@license AGPL-1.0
@author Dorian Pula [dorian.pula@amber-penguin-software.ca]
*/

import React from "react";


export class SiteHeader extends React.Component {
    static get propTypes() {
        return {
            siteName: React.PropTypes.string,
            logo: React.PropTypes.string,
            tagline: React.PropTypes.string
        }
    }

    render() {
        let headerLogoAltText = `${this.props.siteName} logo`;
        return (
            <div className="row">
                <div className="col-lg-10 col-lg-offset-1">
                    <div className="row sea-header">
                        <div className="col-lg-2 col-lg-offset-3">
                            <img className="header_logo" src={ this.props.logo } alt={ headerLogoAltText }/>
                        </div>
                        <div className="col-lg-4">
                            <h1 className="header_title">{ this.props.siteName }</h1>

                            <h2 className="header_tagline">{ this.props.tagline }</h2>
                        </div>
                    </div>
                </div>
            </div>
        );
    }
}
